<?php
$rpcUrl	= "http://er/rpc/RPC2";
$username = 'xixixi';
$password = 'xaxaxa';


require_once 'lime.php';
$t	= new lime_test(null, new lime_output_color());
$t->diag('sfWebRPCPlugin XMLRPC');

// build the xmlrpc client
require_once 'IXR_Library.inc.php';
$client = new IXR_Client($rpcUrl);

//$client->debug = true;

// query remote 
$succeed = $client->query('login', $username, $password);
$t->is($succeed, true, 'call to rpc::login succeed');
if(! $succeed ) throw new Exception("Exception: ".$client->getErrorMessage());
$token = $client->getResponse();


$data['title'] = 'xaxa';
$data['offer_type_id'] = 1;
$data['estate_type_id'] = 1;
$data['building_type_id'] = 1;
$data['disposition_id'] = 1;
$data['ownership_id'] = 1;
$data['area'] = 100;
$data['price'] = 10000;
$data['district_id'] = 1;
$data['city'] = 'Městec Králové';
$data['street'] = 'Dvořákova';
$data['number_pop'] = '879';
$data['zip'] = '28903';

$succeed = $client->query('createEstate', $token, $data);
$t->is($succeed, true, 'call to rpc::createEstate succeed');
if(! $succeed ) throw new Exception("Exception: ".$client->getErrorMessage());
$estateId = $client->getResponse();


$data['title'] = 'xixišěřčšěžřžá';
$succeed = $client->query('updateEstate', $token, $estateId, $data);
$t->is($succeed, true, 'call to rpc::updateEstate succeed');
if(! $succeed ) throw new Exception("Exception: ".$client->getErrorMessage());


$succeed = $client->query('activeEstate', $token, $estateId);
$t->is($succeed, true, 'call to rpc::activeEstate succeed');
if(! $succeed ) throw new Exception("Exception: ".$client->getErrorMessage());


$succeed = $client->query('deactiveEstate', $token, $estateId);
$t->is($succeed, true, 'call to rpc::deactiveEstate succeed');
if(! $succeed ) throw new Exception("Exception: ".$client->getErrorMessage());


$succeed = $client->query('listEstates', $token);
$t->is($succeed, true, 'call to rpc::listEstates succeed');
if(! $succeed ) throw new Exception("Exception: ".$client->getErrorMessage());
//var_dump($client->getResponse());


$handle = fopen('test.png', 'r');
$imgData = fread($handle, filesize('test.png'));
fclose($handle);
$succeed = $client->query('addFoto', $token, $estateId, base64_encode($imgData), 'image/png', 'testt');
$t->is($succeed, true, 'call to rpc::addFoto succeed');
if(! $succeed ) throw new Exception("Exception: ".$client->getErrorMessage());
$fotoId = $client->getResponse();


$handle = fopen('test.png', 'r');
$imgData = fread($handle, filesize('test.png'));
fclose($handle);
$succeed = $client->query('addFoto', $token, $estateId, base64_encode($imgData), 'image/png', 'testt');
$t->is($succeed, true, 'call to rpc::addFoto succeed');
if(! $succeed ) throw new Exception("Exception: ".$client->getErrorMessage());
$fotoId = $client->getResponse();


$succeed = $client->query('listFotos', $token, $estateId);
$t->is($succeed, true, 'call to rpc::listFotos succeed');
if(! $succeed ) throw new Exception("Exception: ".$client->getErrorMessage());
//var_dump($client->getResponse());


$succeed = $client->query('deleteFoto', $token, $fotoId);
$t->is($succeed, true, 'call to rpc::deleteFoto succeed');
if(! $succeed ) throw new Exception("Exception: ".$client->getErrorMessage());


$succeed = $client->query('deleteEstate', $token, $estateId);
$t->is($succeed, true, 'call to rpc::deleteEstate succeed');
if(! $succeed ) throw new Exception("Exception: ".$client->getErrorMessage());


$succeed = $client->query('logout', $token);
$t->is($succeed, true, 'call to rpc::logout succeed');


$t->is($client->query('fctnamej_which_doesnt_exist'), false, 'call to unexisting function fails as expected');




